/*
	ppps_int_heap.h
	[TvCu] int^̃q[v
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.3   '2019/10/2
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB
                 bool^gB
             
             1.0.0   '2013/2/3
*/

#ifndef PPPS_INT_HEAP_H
#define PPPS_INT_HEAP_H

#include <stdbool.h>


/* q[v^ */
typedef struct PPPSIntHeap_tag* PPPSIntHeap;


/*
	q[v

	F
		capacity:	q[v̍őeʁB

	߂lF
		쐬ꂽq[vB
		gIAppps_int_heap_delete֐ɓnč폜B
*/
PPPSIntHeap ppps_int_heap_create(size_t capacity);

/*
	q[v폜

	F
		heap:	q[v
*/
void ppps_int_heap_delete(PPPSIntHeap heap);

/*
	q[vɗvf}

	F
		heap:	q[vւ̃|C^
		value:	}vf̒l
	߂lF
		 trueAs false ԂB
*/
bool ppps_int_heap_insert(PPPSIntHeap heap, int value);

/*
	q[v獪菜

	F
		heap:	q[vւ̃|C^
		value:	菜ꂽvf󂯎AhX
	߂lF
		 trueAs false ԂB
*/
bool ppps_int_heap_remove_root(PPPSIntHeap heap, int* value);

/*
	q[vvfT

	F
		heap:	q[v
		value:	Tovf̒l
	߂lF
		 trueAs false ԂB
*/
bool ppps_int_heap_search(const PPPSIntHeap heap, int value);

/*
	q[vɊi[ĂvfԂ

	F
		heap:	q[v
	߂lF
		i[Ăvf̌B
*/
size_t ppps_int_heap_getsize(const PPPSIntHeap heap);

/*
	q[v̓eo͂

	F
		heap:	q[v
*/
void ppps_int_heap_print(const PPPSIntHeap heap);


#endif
